;7. Programa skaito teksta ir formatuoja pastraipas. I kiekviena
;   eilute bando sukisti maksimuma zodziu, taip, kad eilutes ilgis
;   nevirsytu 75 simboliu. Tarpas eilutes pradzioje ar tuscia
;   eilute laikomi naujos pastraipos pradzia.

;   Povilas Sinkevicius, 10 grupe, informatika.


; Konstantos:
CMDLINE		EQU	80h
SPACE		EQU	20h
BUFSIZE		EQU	1024
LINESIZE	EQU	75
STDIN		EQU	0
STDOUT		EQU	1
ENT		EQU	13
HOME		EQU	10
PASTR_PR	EQU	SPACE

; DOS funkciju numeriai
PRINT		EQU	09h
FOPEN		EQU	3Dh
FCLOSE		EQU	3Eh
READ		EQU	3Fh
WRITE		EQU	40h
EXIT		EQU	4Ch
GETPSP		EQU	62h

; Steko segmentas
Stak		SEGMENT PARA STACK 'STACK'
		DB	256 dup (?)
Stak	ENDS

; Duomenu segmentas:
Data	SEGMENT
argc		DW	?		; cia bus parametru skaicius
argv		DW	256 dup (?)	; cia bus trumpos nuorodos i parametrus
cline		DB	256 dup (?)	; cia bus visa eilute su NULL terminuotais parm
buffer		DB	BUFSIZE dup (?)
buffer2 	DB	BUFSIZE dup (?)
flag_pr		DB	?		; veliavele :)
infile		DW	STDIN
outfile		DW	STDOUT

arg_nr		DW	0	
usage_msg	DB	'prg: [/?] [failas1] [failas2] ...', ENT, HOME
		DB	'      /?  spausdina sia pagalba', ENT, HOME, '$'
error_msg	DB	'prg: Ivyko klaida!', ENT, HOME, '$'
nerra		DB	'Jus neperdavete ne vieno parametro!',ENT, HOME, '$'
NEW_LINE        DB      ENT, HOME, '$'
KITAS		DB	ENT, HOME, '-----------Kitas argumentas-----------',ENT, HOME, '$'
bbb	        DB      '___','$'

Data	ENDS

; Kodo segmentas:
Code	SEGMENT
	ASSUME CS:Code, DS:Data, SS:Stak
;;; ----------------------------------------------------------------------
Start:	
	mov	ax, Stak        ; Inicializuojam segmentu registrus
	mov	ss, ax
	mov	ax, Data
	mov	ds, ax
	mov	es, ax
	mov	flag_pr,0

	call	Args		; issilukstename parametrus	

	cmp	argc, 0		; ar bent vien argument turim?
	ja	NextArg		; kopijuosim infile 0 i outfile 1
	lea	dx,nerra
	mov	ah,PRINT
	int	21h
	jmp	_Exit

NextArg:
	lea	dx,NEW_LINE
	mov	ah,9
	int	21h
	mov	si, [arg_nr]
	add	si, si		; padvigubinam, masyvas wordu
	mov	bp, argv[si]
	cmp	byte ptr [ds:bp], '/'	; ar tai opcija?
	jne	OpenFile
	cmp	byte ptr [ds:bp+1], '?'
	je	Usage
	jmp	Usage

OpenFile:
	mov	ah, FOPEN
	xor	al, al
	mov	dx, bp		; failo vardas
	int	21h
	jc	Error
	mov	infile, ax
	inc	arg_nr
Copy:
	lea	dx, buffer	; Skaitom is ivedimo failo
	mov	ah, READ
	mov	bx, infile
	mov	cx, BUFSIZE	
	int	21h
	jc	Error
	cmp	ax, 0		; baigesi failas
	je	EndCopy

	call	FORMAT
	mov	flag_pr,1

	lea	dx,buffer
	mov	cx, si		;  kiek baitu rasyti, rasom i isvedima
        mov	ah, WRITE
	mov	bx, outfile
	int	21h
	jc	Error
;	lea	dx,bbb
;	mov	ah,9
;	int	21h
;----------------------------------
	push bx
	sub bx,bx
CL3:
	mov buffer2[bx],''
	mov buffer[bx],''
	inc bx
	cmp bx, BUFSIZE
	je ISH_CL3
	jmp  CL3
ISH_CL3:
	pop bx
;----------------------------------
	jmp	Copy

Usage:
	lea	dx, usage_msg
	mov	ah, PRINT
	int	21h
	inc	arg_nr
	mov	ax, arg_nr
	cmp	ax, argc
	je	_Exit
	lea	dx,NEW_LINE
	mov	ah,PRINT
	int	21h
	jmp	NextArg

_Exit:
	mov	ah, 9
	lea	dx, NEW_LINE
	int	21h
	mov	ah, EXIT
	mov	al, 0
	int	21h

Error:
	lea	dx, error_msg
	mov	ah, PRINT
	int	21h
	mov	ah, EXIT
	mov	al, 1
	int	21h

EndCopy:
	mov	ah, FCLOSE
	mov	bx, infile
	int	21h
	
	mov	ax, arg_nr
	cmp	ax, argc
	je	_Exit
	lea	dx,KITAS
	mov	ah,PRINT
	int	21h
	jmp	NextArg


	
;------------------------------------------------------------------
FORMAT PROC

	push	dx
	push	cx
	push	bp
	mov	bp,di
	xor	si,si
	xor	di,di
	xor	bx,bx
	xor	dx,dx

	cmp	flag_pr,1
	je	ciklas1
	mov	buffer2[0],PASTR_PR
	inc	di
	mov	bp,1

ciklas1:
	mov	dl,buffer[si]
	cmp	dl,ENT
	je	nauja_eilute
	cmp	dl,HOME
	je	nauja_eilute
	mov	buffer2[di],dl
	cmp	si,ax
	ja	eilutes
	cmp	si,ax
	je	eilutes
	inc	di
	inc	si
	jmp	ciklas1

nauja_eilute:
	cmp	buffer[si+2],' '
	je nauja_pastraipa
	cmp	buffer[si+2],ENT
	je nauja_pastraipa
	cmp	buffer[si+2],HOME
	je nauja_pastraipa
	mov	buffer2[di],SPACE
	inc	di
	jmp iki_simbol

nauja_pastraipa:
	mov	buffer2[di],ENT
	inc	di
	mov	buffer2[di],HOME
	inc	di
	mov	buffer2[di],PASTR_PR
	inc	di

iki_simbol:
	inc	si
	cmp	buffer[si],ENT
	je	iki_simbol
	cmp	buffer[si],HOME
	je	iki_simbol
	cmp	buffer[si],SPACE
	je	iki_simbol
	jmp	ciklas1	

eilutes:
	xor	bx,bx
	mov	bx,di
	xor	di,di
	xor	si,si

ciklas2:
	cmp	buffer2[di],SPACE
	je	ILGIS
	cmp	buffer2[di],ENT
	je	pastr_galas
	cmp	buffer2[di],HOME
	je	pastr_galas

ATGAL:
	mov	dl,buffer2[di]
	mov	buffer[si],dl
	inc	bp
	inc	si
	inc	di
	cmp	di,bx
	ja	exit_proced
	cmp	di,bx
	je	exit_proced
	jmp	ciklas2

ILGIS:
	push	di
	xor	cx,cx

ILG:
	inc	di
	cmp	buffer2[di],SPACE
	je	ISH_ILG
	cmp	buffer2[di],ENT
	je	ISH_ILG
	cmp	buffer2[di],HOME
	je	ISH_ILG
	inc	cx
	jmp	ILG

ISH_ILG:
	pop	di
	add	cx,bp
	cmp	cx,LINESIZE
	ja	ENT_ER
	jmp	ATGAL

ENT_ER:
	mov	buffer[si],ENT
	inc	si
	mov	buffer[si],HOME
	inc	si
	mov	bp,1
	inc	di
	jmp	ciklas2

pastr_galas:
	mov	buffer[si],ENT
	inc	si
	mov	buffer[si],HOME
	inc	si
	mov	bp,1
	inc	di
	inc	di
	jmp	ciklas2

exit_proced:

	mov	di,bp
	pop	bp
	pop	cx
	pop	dx

	ret
FORMAT ENDP


; Sukramto komandu eilutes argumentus ir sudeda juos C stiliuj:
; argc yra argumentu skaicius, o argv yra pointeriu i juos masyvas.
; Argumentai perkopijuoti  DS, taip kad pointeriai trumpi.
; Tarpas laikomas argumentu separatorium.
Args PROC
	push	es
	push	ds
	push	ax
	push	bx
	mov	ah, GETPSP	; Kvieciames DOS'o funkcij PSP gauti
	int	21h
	mov	ds, bx		; Nukopijuojam eilute  Data:cline
	mov	ax, Data	; Stringines komandos kopijuoja [es:di] <- [ds:si]
	mov	es, ax		; DS = PSP, ES = Data
	mov	di, offset cline
	mov	si, CMDLINE + 1
	mov	cl, [ds:CMDLINE]; eilutes ilgis		
	xor	ch, ch	

				; while (cx--) *es:di++ = *ds:si++;
				; Tiems, kas nesuprato:
				; while cx <> 0 do
				;   begin
				;     es:di^ := ds:si^;
				;     inc(di); 
				;     inc(si); 
				;     dec(cx)			
				;   end

	cld			; clear direction -- adresai cikle dides
rep	movsb
	mov	cl, [ds:CMDLINE]; CX -- ilgis
	mov	ax, Data
	mov	ds, ax		; Atstatom DS i musu Data segment
	xor	si, si		; cia bus offsetas nuo argv pradzios
	xor	bp, bp		; cia bus si/2, suskaiciuotu argumentu skaicius
	mov	al, SPACE
	mov	di, offset cline

loop0:
				; sita instrukcija isoka i ciklo jei CX=0 arba [es:di]=al
repne	scasb			; ieskom tarpo
	jcxz	End0		; jei pasiekem gal (CX=0)
	mov	[argv + si], di
	dec	di		; sugriztam vienu baitu
	mov	byte ptr [di], 0; vietoj 20h istatom 00h
	add	si, 2
	inc	bp
	jmp	loop0

End0:	
	mov	[argc], bp
	pop	bx
	pop	ax
	pop	ds
	pop	es
	ret
Args	ENDP
;;; ----------------------------------------------------------------
Code	ENDS
	END	Start
